diff --git a/sim/.gitignore b/sim/.gitignore
index 0dce65b..abdfed0 100644
--- a/sim/.gitignore
+++ b/sim/.gitignore
@@ -3,5 +3,3 @@
 /*/hw-config.h
 /*/targ-*
 /*/version.c
-
-/common/cconfig.h
diff --git a/sim/ChangeLog b/sim/ChangeLog
index 7318322..93a6ee7 100644
--- a/sim/ChangeLog
+++ b/sim/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* .gitignore: Delete /common/cconfig.h entry.
+
 2016-01-05  Nick Clifton  <nickc@redhat.com>
 
 	* MAINTAINERS: Add myself as AArch64 sim maintainer.
diff --git a/sim/aarch64/ChangeLog b/sim/aarch64/ChangeLog
index c2224b1..134a82f 100644
--- a/sim/aarch64/ChangeLog
+++ b/sim/aarch64/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_create_inferior): Mark argv and env const.
diff --git a/sim/aarch64/config.in b/sim/aarch64/config.in
index fc7af77..f24eb3b 100644
diff --git a/sim/aarch64/configure b/sim/aarch64/configure
index c768886..52f152e 100755
diff --git a/sim/arm/ChangeLog b/sim/arm/ChangeLog
index e769f63..f90d727 100644
--- a/sim/arm/ChangeLog
+++ b/sim/arm/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* wrapper.c (sim_create_inferior): Mark argv and env const.
diff --git a/sim/arm/config.in b/sim/arm/config.in
index fc7af77..f24eb3b 100644
diff --git a/sim/arm/configure b/sim/arm/configure
index ac97233..87674c4 100755
diff --git a/sim/avr/ChangeLog b/sim/avr/ChangeLog
index 3d5b723..441a9370 100644
--- a/sim/avr/ChangeLog
+++ b/sim/avr/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.
diff --git a/sim/avr/config.in b/sim/avr/config.in
index fc7af77..f24eb3b 100644
diff --git a/sim/avr/configure b/sim/avr/configure
index d172c65..11b8fb5 100755
diff --git a/sim/bfin/ChangeLog b/sim/bfin/ChangeLog
index 62f70e3..29e26e1 100644
--- a/sim/bfin/ChangeLog
+++ b/sim/bfin/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (bfin_syscall): Remove first const from argv.
diff --git a/sim/bfin/config.in b/sim/bfin/config.in
index c5223be..65ae650 100644
diff --git a/sim/bfin/configure b/sim/bfin/configure
index ae49198..e88168c 100755
diff --git a/sim/common/ChangeLog b/sim/common/ChangeLog
index d2aa37e..42f3767 100644
--- a/sim/common/ChangeLog
+++ b/sim/common/ChangeLog
@@ -1,3 +1,17 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* configure.ac: Change SIM_AC_COMMON to AC_PROG_CC.  Drop 2nd arg
+	to AC_OUTPUT.  Move AC_CHECK_HEADERS, AC_CHECK_FUNCS,
+	AC_CHECK_MEMBERS, and -AC_CHECK_TYPES ...
+	* acinclude.m4 (SIM_AC_COMMON): ... here.
+	* aclocal.m4, configure: Regenerate.
+	* config.in: Delete file.
+	* callback.c: Change cconfig.h include to config.h.
+	* dv-cfi.c, nrun.c, sim-basics.h, sim-load.c, sim-memopt.c,
+	syscall.c: Likewise.
+	* Make-common.in (sim-basics_h): Delete ../common/cconfig.h.
+	* Makefile.in (distclean): Delete rm -f cconfig.h config.h stamp-h.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-config.c (print_sim_config): Delete sim_io_printf of version,
diff --git a/sim/common/Make-common.in b/sim/common/Make-common.in
index 6fdf10f..30844cc 100644
--- a/sim/common/Make-common.in
+++ b/sim/common/Make-common.in
@@ -357,7 +357,6 @@ sim-base_h = $(srccom)/sim-base.h \
 		$(sim-memopt_h) \
 		$(sim-cpu_h)
 sim-basics_h = $(srccom)/sim-basics.h \
-		../common/cconfig.h \
 		$(sim-config_h) \
 		$(callback_h) \
 		$(sim-inline_h) \
diff --git a/sim/common/Makefile.in b/sim/common/Makefile.in
index fbdb0d1..c249b4b 100644
--- a/sim/common/Makefile.in
+++ b/sim/common/Makefile.in
@@ -110,7 +110,6 @@ clean:
 distclean mostlyclean maintainer-clean realclean: clean
 	rm -f TAGS
 	rm -f Makefile config.cache config.log config.status
-	rm -f cconfig.h config.h stamp-h
 
 # Dummy target to force execution of dependent targets.
 force:
diff --git a/sim/common/acinclude.m4 b/sim/common/acinclude.m4
index 47bc2de..a746ca8 100644
--- a/sim/common/acinclude.m4
+++ b/sim/common/acinclude.m4
@@ -84,10 +84,26 @@ ZW_GNU_GETTEXT_SISTER_DIR(../../intl)
 # FIXME: Seems to me this can cause problems for i386-windows hosts.
 # At one point there were hardcoded AC_DEFINE's if ${host} = i386-*-windows*.
 AC_CHECK_HEADERS(stdlib.h string.h strings.h unistd.h time.h)
-AC_CHECK_HEADERS(sys/time.h sys/resource.h)
+AC_CHECK_HEADERS(sys/time.h sys/times.h sys/resource.h sys/mman.h)
 AC_CHECK_HEADERS(fcntl.h fpu_control.h)
 AC_CHECK_HEADERS(dlfcn.h errno.h sys/stat.h)
 AC_CHECK_FUNCS(getrusage time sigaction __setfpucw)
+AC_CHECK_FUNCS(mmap munmap lstat truncate ftruncate posix_fallocate)
+AC_CHECK_MEMBERS([[struct stat.st_dev], [struct stat.st_ino],
+[struct stat.st_mode], [struct stat.st_nlink], [struct stat.st_uid],
+[struct stat.st_gid], [struct stat.st_rdev], [struct stat.st_size],
+[struct stat.st_blksize], [struct stat.st_blocks], [struct stat.st_atime],
+[struct stat.st_mtime], [struct stat.st_ctime]], [], [],
+[[#ifdef HAVE_SYS_TYPES_H
+#include <sys/types.h>
+#endif
+#ifdef HAVE_SYS_STAT_H
+#include <sys/stat.h>
+#endif]])
+AC_CHECK_TYPES(socklen_t, [], [],
+[#include <sys/types.h>
+#include <sys/socket.h>
+])
 
 # Check for socket libraries
 AC_CHECK_LIB(socket, bind)
diff --git a/sim/common/aclocal.m4 b/sim/common/aclocal.m4
index ab25a05..cdae6e7 100644
diff --git a/sim/common/callback.c b/sim/common/callback.c
index b8c1168..f9489cc 100644
--- a/sim/common/callback.c
+++ b/sim/common/callback.c
@@ -21,9 +21,8 @@
    level.  */
 
 #ifdef HAVE_CONFIG_H
-#include "cconfig.h"
-#endif
 #include "config.h"
+#endif
 #include "ansidecl.h"
 #include <stdarg.h>
 #include <stdio.h>
diff --git a/sim/common/config.in b/sim/common/config.in
deleted file mode 100644
index f24eb3b..0000000
diff --git a/sim/common/configure b/sim/common/configure
index 6f2e492..3b11fbb 100755
diff --git a/sim/common/configure.ac b/sim/common/configure.ac
index e771575..473e911 100644
--- a/sim/common/configure.ac
+++ b/sim/common/configure.ac
@@ -2,7 +2,7 @@ dnl Process this file with autoconf to produce a configure script.
 AC_PREREQ(2.64)dnl
 AC_INIT(Makefile.in)
 
-SIM_AC_COMMON(cconfig.h)
+AC_PROG_CC
 
 # Put a useful copy of CPP_FOR_TARGET in Makefile.
 # This is only used to build the target values header files.  These files are
@@ -32,24 +32,4 @@ else
 fi
 AC_SUBST(TARGET_SUBDIR)
 
-# These aren't all needed yet, but will be eventually.
-AC_CHECK_HEADERS(stdlib.h string.h strings.h time.h sys/times.h sys/stat.h sys/mman.h)
-AC_CHECK_FUNCS(mmap munmap lstat truncate ftruncate posix_fallocate)
-AC_CHECK_MEMBERS([[struct stat.st_dev], [struct stat.st_ino],
-[struct stat.st_mode], [struct stat.st_nlink], [struct stat.st_uid],
-[struct stat.st_gid], [struct stat.st_rdev], [struct stat.st_size],
-[struct stat.st_blksize], [struct stat.st_blocks], [struct stat.st_atime],
-[struct stat.st_mtime], [struct stat.st_ctime]], [], [],
-[[#ifdef HAVE_SYS_TYPES_H
-#include <sys/types.h>
-#endif
-#ifdef HAVE_SYS_STAT_H
-#include <sys/stat.h>
-#endif]])
-AC_CHECK_TYPES(socklen_t, [], [],
-[#include <sys/types.h>
-#include <sys/socket.h>
-])
-
-AC_OUTPUT(Makefile,
-[case x$CONFIG_HEADERS in xcconfig.h:config.in) echo > stamp-h ;; esac])
+AC_OUTPUT(Makefile)
diff --git a/sim/common/dv-cfi.c b/sim/common/dv-cfi.c
index 19677cb..19ea9a4 100644
--- a/sim/common/dv-cfi.c
+++ b/sim/common/dv-cfi.c
@@ -22,7 +22,7 @@
 
 /* TODO: support vendor query tables.  */
 
-#include "cconfig.h"
+#include "config.h"
 
 #include <math.h>
 #include <errno.h>
diff --git a/sim/common/nrun.c b/sim/common/nrun.c
index 94ba35d..6616cc1 100644
--- a/sim/common/nrun.c
+++ b/sim/common/nrun.c
@@ -16,7 +16,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
 /* Need to be before general includes, to pick up e.g. _GNU_SOURCE.  */
 #ifdef HAVE_CONFIG_H
-#include "cconfig.h"
+#include "config.h"
 #endif
 
 #include <signal.h>
diff --git a/sim/common/sim-basics.h b/sim/common/sim-basics.h
index 16c7eb5..9f34e2f 100644
--- a/sim/common/sim-basics.h
+++ b/sim/common/sim-basics.h
@@ -27,7 +27,7 @@
 /* Basic configuration */
 
 #ifdef HAVE_CONFIG_H
-#include "cconfig.h"
+#include "config.h"
 #endif
 
 /* Basic host dependant mess - hopefully <stdio.h> + <stdarg.h> will
diff --git a/sim/common/sim-load.c b/sim/common/sim-load.c
index fee6e8f..701b60e 100644
--- a/sim/common/sim-load.c
+++ b/sim/common/sim-load.c
@@ -19,7 +19,7 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
    to suggest that they shouldn't :-)].  */
 
 #ifdef HAVE_CONFIG_H
-#include "cconfig.h"
+#include "config.h"
 #endif
 #include "ansidecl.h"
 #include <stdio.h> /* for NULL */
diff --git a/sim/common/sim-memopt.c b/sim/common/sim-memopt.c
index ab43916..eb88fc9 100644
--- a/sim/common/sim-memopt.c
+++ b/sim/common/sim-memopt.c
@@ -17,7 +17,7 @@ GNU General Public License for more details.
 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.  */
 
-#include "cconfig.h"
+#include "config.h"
 
 #include "sim-main.h"
 #include "sim-assert.h"
diff --git a/sim/common/syscall.c b/sim/common/syscall.c
index 4fa4e27..d660722 100644
--- a/sim/common/syscall.c
+++ b/sim/common/syscall.c
@@ -24,7 +24,7 @@
    supported.  */
 
 #ifdef HAVE_CONFIG_H
-#include "cconfig.h"
+#include "config.h"
 #endif
 #include "ansidecl.h"
 #include "libiberty.h"
diff --git a/sim/cr16/ChangeLog b/sim/cr16/ChangeLog
index 6540eed..ca0674c 100644
--- a/sim/cr16/ChangeLog
+++ b/sim/cr16/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.
diff --git a/sim/cr16/config.in b/sim/cr16/config.in
index fc7af77..f24eb3b 100644
diff --git a/sim/cr16/configure b/sim/cr16/configure
index ae62ac3..f6b04b3 100755
diff --git a/sim/cris/ChangeLog b/sim/cris/ChangeLog
index 66231ce..592b20e 100644
--- a/sim/cris/ChangeLog
+++ b/sim/cris/ChangeLog
@@ -1,3 +1,8 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+	* rvdummy.c: Change cconfig.h to config.h.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (sim_open): Mark argv const.
diff --git a/sim/cris/config.in b/sim/cris/config.in
index 1734eea..e5e69a8 100644
diff --git a/sim/cris/configure b/sim/cris/configure
index 7aa81f0..6f2653e 100755
diff --git a/sim/cris/rvdummy.c b/sim/cris/rvdummy.c
index 7a384bf..3b66bb0 100644
--- a/sim/cris/rvdummy.c
+++ b/sim/cris/rvdummy.c
@@ -30,7 +30,7 @@ main (int argc, char *argv[])
 #else
 
 #ifdef HAVE_CONFIG_H
-#include "cconfig.h"
+#include "config.h"
 #endif
 
 #include "getopt.h"
diff --git a/sim/d10v/ChangeLog b/sim/d10v/ChangeLog
index 0941a34..10e0d3f 100644
--- a/sim/d10v/ChangeLog
+++ b/sim/d10v/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.
diff --git a/sim/d10v/config.in b/sim/d10v/config.in
index fc7af77..f24eb3b 100644
diff --git a/sim/d10v/configure b/sim/d10v/configure
index ac97233..87674c4 100755
diff --git a/sim/erc32/ChangeLog b/sim/erc32/ChangeLog
index c9a3522..d49c23c 100644
--- a/sim/erc32/ChangeLog
+++ b/sim/erc32/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interf.c (sim_open): Mark argv const.
diff --git a/sim/erc32/config.in b/sim/erc32/config.in
index fc7af77..f24eb3b 100644
diff --git a/sim/erc32/configure b/sim/erc32/configure
index 098c3cf..2a66388 100755
diff --git a/sim/frv/ChangeLog b/sim/frv/ChangeLog
index 684bcd5..66d73ff 100644
--- a/sim/frv/ChangeLog
+++ b/sim/frv/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (sim_open): Mark argv const.
diff --git a/sim/frv/config.in b/sim/frv/config.in
index 0f50442..6a83434 100644
diff --git a/sim/frv/configure b/sim/frv/configure
index 82bd09f..207534b 100755
diff --git a/sim/ft32/ChangeLog b/sim/ft32/ChangeLog
index 7f98a34..1be9545 100644
--- a/sim/ft32/ChangeLog
+++ b/sim/ft32/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.
diff --git a/sim/ft32/config.in b/sim/ft32/config.in
index fc7af77..f24eb3b 100644
diff --git a/sim/ft32/configure b/sim/ft32/configure
index 6ce4ef4..cc8f393 100755
diff --git a/sim/h8300/ChangeLog b/sim/h8300/ChangeLog
index 544b745..a18cc8e 100644
--- a/sim/h8300/ChangeLog
+++ b/sim/h8300/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* compile.c (sim_open): Mark argv const.
diff --git a/sim/h8300/config.in b/sim/h8300/config.in
index b38ed02..f4d3978 100644
diff --git a/sim/h8300/configure b/sim/h8300/configure
index 4865f20..0d39176 100755
diff --git a/sim/iq2000/ChangeLog b/sim/iq2000/ChangeLog
index 3d0d7f6..26d315c 100644
--- a/sim/iq2000/ChangeLog
+++ b/sim/iq2000/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (sim_open): Mark argv const.
diff --git a/sim/iq2000/config.in b/sim/iq2000/config.in
index 0f50442..6a83434 100644
diff --git a/sim/iq2000/configure b/sim/iq2000/configure
index fba8dc1..5678ee7 100755
diff --git a/sim/lm32/ChangeLog b/sim/lm32/ChangeLog
index 9d3c215..8f2bbfc 100644
--- a/sim/lm32/ChangeLog
+++ b/sim/lm32/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (sim_open): Mark argv const.
diff --git a/sim/lm32/config.in b/sim/lm32/config.in
index 0f50442..6a83434 100644
diff --git a/sim/lm32/configure b/sim/lm32/configure
index c392d23..d562850 100755
diff --git a/sim/m32c/ChangeLog b/sim/m32c/ChangeLog
index e3ea0c8..331839e 100644
--- a/sim/m32c/ChangeLog
+++ b/sim/m32c/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (sim_open): Mark argv const.
diff --git a/sim/m32c/config.in b/sim/m32c/config.in
index 950375a..3ba123f 100644
diff --git a/sim/m32c/configure b/sim/m32c/configure
index e20c88d..2a6398d 100755
diff --git a/sim/m32r/ChangeLog b/sim/m32r/ChangeLog
index 32cfa37..9345e0a 100644
--- a/sim/m32r/ChangeLog
+++ b/sim/m32r/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (sim_open): Mark argv const.
diff --git a/sim/m32r/config.in b/sim/m32r/config.in
index 0f50442..6a83434 100644
diff --git a/sim/m32r/configure b/sim/m32r/configure
index b4a1bd6..78125db 100755
diff --git a/sim/m68hc11/ChangeLog b/sim/m68hc11/ChangeLog
index dcc363d..afe6460 100644
--- a/sim/m68hc11/ChangeLog
+++ b/sim/m68hc11/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.
diff --git a/sim/m68hc11/config.in b/sim/m68hc11/config.in
index 0f50442..6a83434 100644
diff --git a/sim/m68hc11/configure b/sim/m68hc11/configure
index 667b901..dc57b61 100755
diff --git a/sim/mcore/ChangeLog b/sim/mcore/ChangeLog
index 04e6aee..c429371 100644
--- a/sim/mcore/ChangeLog
+++ b/sim/mcore/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.
diff --git a/sim/mcore/config.in b/sim/mcore/config.in
index fc7af77..f24eb3b 100644
diff --git a/sim/mcore/configure b/sim/mcore/configure
index ac97233..87674c4 100755
diff --git a/sim/microblaze/ChangeLog b/sim/microblaze/ChangeLog
index 8b3f4b4..f2fc2af 100644
--- a/sim/microblaze/ChangeLog
+++ b/sim/microblaze/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.
diff --git a/sim/microblaze/config.in b/sim/microblaze/config.in
index fc7af77..f24eb3b 100644
diff --git a/sim/microblaze/configure b/sim/microblaze/configure
index ac97233..87674c4 100755
diff --git a/sim/mips/ChangeLog b/sim/mips/ChangeLog
index 12c8b6c..f43e36b 100644
--- a/sim/mips/ChangeLog
+++ b/sim/mips/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.
diff --git a/sim/mips/config.in b/sim/mips/config.in
index 70bf5ca..252be50 100644
diff --git a/sim/mips/configure b/sim/mips/configure
index 51fd7f6..7bf62ea 100755
diff --git a/sim/mn10300/ChangeLog b/sim/mn10300/ChangeLog
index fd5b235..f1df49e 100644
--- a/sim/mn10300/ChangeLog
+++ b/sim/mn10300/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.
diff --git a/sim/mn10300/config.in b/sim/mn10300/config.in
index 664dc35..5ca6940 100644
diff --git a/sim/mn10300/configure b/sim/mn10300/configure
index d34446a..f6bad04 100755
diff --git a/sim/moxie/ChangeLog b/sim/moxie/ChangeLog
index 8e17523..b2fcfb5 100644
--- a/sim/moxie/ChangeLog
+++ b/sim/moxie/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.
diff --git a/sim/moxie/config.in b/sim/moxie/config.in
index fc7af77..f24eb3b 100644
diff --git a/sim/moxie/configure b/sim/moxie/configure
index 1ee1887..dc1ffd1 100755
diff --git a/sim/msp430/ChangeLog b/sim/msp430/ChangeLog
index 3ef9051..9006c7f 100644
--- a/sim/msp430/ChangeLog
+++ b/sim/msp430/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* msp430-sim.c (sim_open): Mark argv const.
diff --git a/sim/msp430/config.in b/sim/msp430/config.in
index bbccc94..5a5b182 100644
diff --git a/sim/msp430/configure b/sim/msp430/configure
index 8e5d572..dc55890 100755
diff --git a/sim/rl78/ChangeLog b/sim/rl78/ChangeLog
index a3f3106..0d35ab0 100644
--- a/sim/rl78/ChangeLog
+++ b/sim/rl78/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* gdb-if.c (sim_open): Mark argv const.
diff --git a/sim/rl78/config.in b/sim/rl78/config.in
index bbccc94..5a5b182 100644
diff --git a/sim/rl78/configure b/sim/rl78/configure
index d85339a..7ba111e 100755
diff --git a/sim/rx/ChangeLog b/sim/rx/ChangeLog
index dbe6634..cff5fc8 100644
--- a/sim/rx/ChangeLog
+++ b/sim/rx/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* gdb-if.c (sim_open): Mark argv const.
diff --git a/sim/rx/config.in b/sim/rx/config.in
index 6613874..c64ed76 100644
diff --git a/sim/rx/configure b/sim/rx/configure
index 7c4a02b..c62fdc3 100755
diff --git a/sim/sh/ChangeLog b/sim/sh/ChangeLog
index 4d5ba4f..f7a57bc 100644
--- a/sim/sh/ChangeLog
+++ b/sim/sh/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.
diff --git a/sim/sh/config.in b/sim/sh/config.in
index fc7af77..f24eb3b 100644
diff --git a/sim/sh/configure b/sim/sh/configure
index ac97233..87674c4 100755
diff --git a/sim/sh64/ChangeLog b/sim/sh64/ChangeLog
index 149d6e1..f430b46 100644
--- a/sim/sh64/ChangeLog
+++ b/sim/sh64/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* sim-if.c (sim_open): Mark argv const.
diff --git a/sim/sh64/config.in b/sim/sh64/config.in
index 0f50442..6a83434 100644
diff --git a/sim/sh64/configure b/sim/sh64/configure
index 6516f31..e180eef 100755
diff --git a/sim/v850/ChangeLog b/sim/v850/ChangeLog
index d839a9a..f9b14fa 100644
--- a/sim/v850/ChangeLog
+++ b/sim/v850/ChangeLog
@@ -1,3 +1,7 @@
+2016-01-09  Mike Frysinger  <vapier@gentoo.org>
+
+	* config.in, configure: Regenerate.
+
 2016-01-06  Mike Frysinger  <vapier@gentoo.org>
 
 	* interp.c (sim_open): Mark argv const.